Index: LMDZ6/branches/contrails/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/phys_state_var_mod.F90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/phys_state_var_mod.F90	(revision 5609)
@@ -94,6 +94,10 @@
       REAL, ALLOCATABLE, SAVE :: cf_ancien(:,:), qvc_ancien(:,:)
 !$OMP THREADPRIVATE(cf_ancien, qvc_ancien)
-      REAL, ALLOCATABLE, SAVE :: cfa_ancien(:,:), qta_ancien(:,:)
-!$OMP THREADPRIVATE(cfa_ancien, qta_ancien)
+      REAL, ALLOCATABLE, SAVE :: cfa_ancien(:,:), pcf_ancien(:,:)
+!$OMP THREADPRIVATE(cfa_ancien, pcf_ancien)
+      REAL, ALLOCATABLE, SAVE :: qva_ancien(:,:), qia_ancien(:,:)
+!$OMP THREADPRIVATE(qva_ancien, qia_ancien)
+      REAL, ALLOCATABLE, SAVE :: cwcon(:,:), cwcon0(:,:)
+!$OMP THREADPRIVATE(cwcon, cwcon0)
 !!! RomP >>>
       REAL, ALLOCATABLE, SAVE :: tr_ancien(:,:,:)
@@ -590,5 +594,7 @@
       ALLOCATE(u_ancien(klon,klev), v_ancien(klon,klev))
       ALLOCATE(cf_ancien(klon,klev), qvc_ancien(klon,klev))
-      ALLOCATE(cfa_ancien(klon,klev), qta_ancien(klon,klev))
+      ALLOCATE(cfa_ancien(klon,klev), pcf_ancien(klon,klev))
+      ALLOCATE(qva_ancien(klon,klev), qia_ancien(klon,klev))
+      ALLOCATE(cwcon(klon,klev), cwcon0(klon,klev))
 !!! Rom P >>>
       ALLOCATE(tr_ancien(klon,klev,nbtr))
@@ -817,5 +823,7 @@
       DEALLOCATE(qtc_cv,sigt_cv,detrain_cv,fm_cv)
       DEALLOCATE(u_ancien, v_ancien)
-      DEALLOCATE(cf_ancien, qvc_ancien, cfa_ancien, qta_ancien)
+      DEALLOCATE(cf_ancien, qvc_ancien, cfa_ancien, pcf_ancien)
+      DEALLOCATE(qva_ancien, qia_ancien)
+      DEALLOCATE(cwcon, cwcon0)
       DEALLOCATE(tr_ancien)                           !RomP
       DEALLOCATE(ratqs, pbl_tke,coefh,coefm)
Index: LMDZ6/branches/contrails/libf/phylmd/physiq_mod.F90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/physiq_mod.F90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/physiq_mod.F90	(revision 5609)
@@ -328,7 +328,7 @@
        dqvc_adj, dqvc_sub, dqvc_con, dqvc_mix, qsatliq, qsatice, &
        !-- LSCP - aviation and contrails variables
-       cfa_seri, qta_seri, d_cfa_dyn, d_qta_dyn, &
-       d_q_avi, flight_dist, flight_h2o, &
-       qice_cont, Tcritcont, qcritcont, potcontfraP, potcontfraNP, &
+       cfa_seri, pcf_seri, qva_seri, qia_seri, d_cfa_dyn, d_pcf_dyn, d_qva_dyn, d_qia_dyn, &
+       d_q_avi, flight_dist, flight_h2o, qice_perscont, &
+       Tcritcont, qcritcont, potcontfraP, potcontfraNP, &
        cldfra_nocont, cldtau_nocont, cldemi_nocont, cldh_nocont, &
        conttau, contemi, contcov, fiwp_nocont, fiwc_nocont, ref_ice_nocont, &
@@ -518,6 +518,6 @@
     !
     ! indices de traceurs eau vapeur, liquide, glace, fraction nuageuse LS (optional), blowing snow (optional)
-    INTEGER,SAVE :: ivap, iliq, isol, ibs, icf, iqvc, icfa, iqta
-!$OMP THREADPRIVATE(ivap, iliq, isol, ibs, icf, iqvc, icfa, iqta)
+    INTEGER,SAVE :: ivap, iliq, isol, ibs, icf, iqvc, icfa, ipcf, iqia, iqva
+!$OMP THREADPRIVATE(ivap, iliq, isol, ibs, icf, iqvc, icfa, ipcf, iqia, iqva)
     !
     !
@@ -1363,8 +1363,10 @@
        isol = strIdx(tracers(:)%name, addPhase('H2O', 's'))
        ibs  = strIdx(tracers(:)%name, addPhase('H2O', 'b'))
-       icf  = strIdx(tracers(:)%name, addPhase('H2O', 'f'))
-       iqvc = strIdx(tracers(:)%name, addPhase('H2O', 'c'))
-       icfa = strIdx(tracers(:)%name, addPhase('H2O', 'a'))
-       iqta = strIdx(tracers(:)%name, addPhase('H2O', 'q'))
+       icf  = strIdx(tracers(:)%name, 'CLDFRA')
+       iqvc = strIdx(tracers(:)%name, 'CLDVAP_g')
+       icfa = strIdx(tracers(:)%name, 'CONTFRA')
+       ipcf = strIdx(tracers(:)%name, 'PERSCONTFRA')
+       iqva = strIdx(tracers(:)%name, 'CONTWATER_g')
+       iqia = strIdx(tracers(:)%name, 'CONTWATER_s')
 !       CALL init_etat0_limit_unstruct
 !       IF (.NOT. create_etat0_limit) CALL init_limit_read(days_elapsed)
@@ -1414,7 +1416,8 @@
        ENDIF
 
-       IF (ok_ice_supersat.AND.(nqo.LT.5)) THEN
-          WRITE (lunout, *) ' ok_ice_supersat=y requires 5 H2O tracers ', &
-               '(H2O_g, H2O_l, H2O_s, H2O_f, H2O_c) but nqo=', nqo, '. Might as well stop here.'
+       IF (ok_ice_supersat.AND.((icf.EQ.0).OR.(iqvc.EQ.0))) THEN
+          WRITE (lunout, *) ' ok_ice_supersat=y requires 5 tracers ', &
+               '(H2O_g, H2O_l, H2O_s, CLDFRA, CLDVAP_g) but not all are ', &
+               'provided. Might as well stop here.'
           abort_message='see above'
           CALL abort_physic(modname,abort_message,1)
@@ -1433,7 +1436,8 @@
        ENDIF
 
-       IF (ok_plane_contrail.AND.(nqo.LT.6)) THEN
-          WRITE (lunout, *) ' ok_plane_contrail=y requires 6 H2O tracers ', &
-              '(H2O_g, H2O_l, H2O_s, H2O_f, H2O_c, H2O_a) but nqo=', nqo, '. Might as well stop here.'
+       IF (ok_plane_contrail.AND.((icfa.EQ.0).OR.(iqva.EQ.0).OR.(iqia.EQ.0).OR.(ipcf.EQ.0))) THEN
+          WRITE (lunout, *) ' ok_plane_contrail=y requires 8 tracers ', &
+              '(H2O_g, H2O_l, H2O_s, CLDFRA, CLDVAP_g, CONTFRA, PERSCONTFRA, CONTWATER_s) ', &
+              'but not all are provided. Might as well stop here.'
           abort_message='see above'
           CALL abort_physic(modname,abort_message,1)
@@ -1446,12 +1450,10 @@
        ENDIF
 
-        IF (ok_bs) THEN
-         IF ((ok_ice_supersat.AND.nqo .LT.6).OR.(.NOT.ok_ice_supersat.AND.nqo.LT.4)) THEN
-             WRITE (lunout, *) 'activation of blowing snow needs a specific H2O tracer', &
-                               'but nqo=', nqo
-             abort_message='see above'
-             CALL abort_physic(modname,abort_message, 1)
-         ENDIF
-        ENDIF
+       IF (ok_bs.AND.(nqo.LT.4)) THEN
+          WRITE (lunout, *) 'activation of blowing snow needs a specific H2O tracer', &
+                            'but nqo=', nqo
+          abort_message='see above'
+          CALL abort_physic(modname,abort_message, 1)
+       ENDIF
 
        Ncvpaseq1 = 0
@@ -1631,4 +1633,7 @@
        rnebcon(:,:) = 0.0
        clwcon(:,:) = 0.0
+       !--AB for prognostic clouds
+       cwcon0(:,:) = 0.0
+       cwcon(:,:) = 0.0
 
        !
@@ -2454,27 +2459,28 @@
           q_seri(i,k)  = qx(i,k,ivap)
           ql_seri(i,k) = qx(i,k,iliq)
+          qs_seri(i,k) = 0.
           qbs_seri(i,k)= 0.
           cf_seri(i,k) = 0.
           qvc_seri(i,k)= 0.
           cfa_seri(i,k)= 0.
-          qta_seri(i,k)= 0.
+          pcf_seri(i,k)= 0.
+          qva_seri(i,k)= 0.
+          qia_seri(i,k)= 0.
           !CR: ATTENTION, on rajoute la variable glace
-          IF (nqo.EQ.2) THEN             !--vapour and liquid only
-             qs_seri(i,k) = 0.
-          ELSE IF (nqo.EQ.3) THEN        !--vapour, liquid and ice
+          IF (nqo .GE. 3) THEN        !--vapour, liquid and ice
              qs_seri(i,k) = qx(i,k,isol)
-          ELSE IF (nqo.GE.4) THEN        !--vapour, liquid, ice, blowing snow, cloud fraction and cloudy water vapor to total water vapor ratio
-             qs_seri(i,k) = qx(i,k,isol)
-             IF (ok_ice_supersat) THEN
-               cf_seri(i,k) = qx(i,k,icf)
-               qvc_seri(i,k) = qx(i,k,iqvc)
-             ENDIF
-             IF (ok_plane_contrail) THEN
-               cfa_seri(i,k) = qx(i,k,icfa)
-               qta_seri(i,k) = qx(i,k,iqta)
-             ENDIF
-             IF (ok_bs) THEN
-               qbs_seri(i,k)= qx(i,k,ibs)
-             ENDIF
+          ENDIF
+          IF (ok_bs) THEN
+             qbs_seri(i,k) = qx(i,k,ibs)
+          ENDIF
+          IF (ok_ice_supersat) THEN
+             cf_seri(i,k)  = qx(i,k,icf)
+             qvc_seri(i,k) = qx(i,k,iqvc)
+          ENDIF
+          IF (ok_plane_contrail) THEN
+             cfa_seri(i,k) = qx(i,k,icfa)
+             pcf_seri(i,k) = qx(i,k,ipcf)
+             qva_seri(i,k) = qx(i,k,iqva)
+             qia_seri(i,k) = qx(i,k,iqia)
           ENDIF
        ENDDO
@@ -2552,5 +2558,7 @@
        d_qvc_dyn(:,:)= (qvc_seri(:,:)-qvc_ancien(:,:))/phys_tstep
        d_cfa_dyn(:,:)= (cfa_seri(:,:)-cfa_ancien(:,:))/phys_tstep
-       d_qta_dyn(:,:)= (qta_seri(:,:)-qta_ancien(:,:))/phys_tstep
+       d_pcf_dyn(:,:)= (pcf_seri(:,:)-pcf_ancien(:,:))/phys_tstep
+       d_qva_dyn(:,:)= (qva_seri(:,:)-qva_ancien(:,:))/phys_tstep
+       d_qia_dyn(:,:)= (qia_seri(:,:)-qia_ancien(:,:))/phys_tstep
        CALL water_int(klon,klev,q_seri,zmasse,zx_tmp_fi2d)
        d_q_dyn2d(:)=(zx_tmp_fi2d(:)-prw_ancien(:))/phys_tstep
@@ -2575,5 +2583,7 @@
        d_qvc_dyn(:,:)= 0.0
        d_cfa_dyn(:,:)= 0.0
-       d_qta_dyn(:,:)= 0.0
+       d_pcf_dyn(:,:)= 0.0
+       d_qva_dyn(:,:)= 0.0
+       d_qia_dyn(:,:)= 0.0
        d_q_dyn2d(:)  = 0.0
        d_ql_dyn2d(:) = 0.0
@@ -2700,10 +2710,12 @@
             qi_seri_lscp(i,k) = qs_seri(i,k) / ( q_seri(i,k) + ql_seri(i,k) + qs_seri(i,k) )
             qvc_seri(i,k) = qvc_seri(i,k) / ( q_seri(i,k) + ql_seri(i,k) + qs_seri(i,k) )
-            qta_seri(i,k) = qta_seri(i,k) / ( q_seri(i,k) + ql_seri(i,k) + qs_seri(i,k) )
+            qva_seri(i,k) = qva_seri(i,k) / ( q_seri(i,k) + ql_seri(i,k) + qs_seri(i,k) )
+            qia_seri(i,k) = qia_seri(i,k) / ( q_seri(i,k) + ql_seri(i,k) + qs_seri(i,k) )
           ELSE
             ql_seri_lscp(i,k) = 0.
             qi_seri_lscp(i,k) = 0.
             qvc_seri(i,k) = 0.
-            qta_seri(i,k) = 0.
+            qva_seri(i,k) = 0.
+            qia_seri(i,k) = 0.
           ENDIF
         ENDDO
@@ -3927,4 +3939,5 @@
         DO i = 1, klon
           qvc_seri(i,k) = qvc_seri(i,k) * q_seri(i,k)
+          cwcon0(i,k) = zqsat(i,k)
         ENDDO
       ENDDO
@@ -3933,5 +3946,6 @@
       DO k = 1, klev
         DO i = 1, klon
-          qta_seri(i,k) = qta_seri(i,k) * q_seri(i,k)
+          qva_seri(i,k) = qva_seri(i,k) * q_seri(i,k)
+          qia_seri(i,k) = qia_seri(i,k) * q_seri(i,k)
         ENDDO
       ENDDO
@@ -3945,6 +3959,6 @@
 
     CALL lscp(klon,klev,phys_tstep,missing_val,paprs,pplay,omega, &
-         t_seri, q_seri, ql_seri_lscp, qi_seri_lscp, &
-         ptconv, rnebcon0, clwcon0, ratqs, sigma_qtherm, &
+         t_seri, q_seri, ql_seri_lscp, qi_seri_lscp, ratqs, sigma_qtherm, &
+         ptconv, rnebcon, cwcon, clwcon, rnebcon0, cwcon0, clwcon0, &
          d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, rneblsvol, &
          pfraclr, pfracld, cldfraliq, sigma2_icefracturb, mean_icefracturb,  &
@@ -3960,6 +3974,6 @@
          dcf_sub, dcf_con, dcf_mix, dqi_adj, dqi_sub, dqi_con, dqi_mix, &
          dqvc_adj, dqvc_sub, dqvc_con, dqvc_mix, qsatliq, qsatice, &
-         cfa_seri, qta_seri, flight_dist, flight_h2o, &
-         qice_cont, Tcritcont, qcritcont, potcontfraP, potcontfraNP, &
+         cfa_seri, pcf_seri, qva_seri, qia_seri, flight_dist, flight_h2o, &
+         qice_perscont, Tcritcont, qcritcont, potcontfraP, potcontfraNP, &
          cloudth_sth,cloudth_senv,cloudth_sigmath,cloudth_sigmaenv, &
          qraindiag, qsnowdiag, dqreva, dqssub, dqrauto, dqrcol, dqrmelt, &
@@ -3967,4 +3981,5 @@
          dqised, dcfsed, dqvcsed)
 
+    IF (ok_ice_supersat) cwcon(:,:) = cwcon0(:,:)
 
     ELSE
@@ -4513,6 +4528,6 @@
                zfice, dNovrN, ptconv, rnebcon, clwcon, &
                !--AB contrails
-               cfa_seri, qice_cont, cldfra_nocont, cldtau_nocont, cldemi_nocont, &
-               conttau, contemi, cldh_nocont, contcov, &
+               cfa_seri, pcf_seri, qia_seri, qice_perscont, cldfra_nocont, &
+               cldtau_nocont, cldemi_nocont, conttau, contemi, cldh_nocont, contcov, &
                fiwp_nocont, fiwc_nocont, ref_ice_nocont)
 
@@ -5709,18 +5724,17 @@
              d_qx(i,k,isol) = ( qs_seri(i,k) - qx(i,k,isol) ) / phys_tstep
           ENDIF
-          !--ice_supersat: nqo=5, we add cloud fraction and cloudy water vapor to total water vapor ratio
-          IF (nqo.ge.5 .and. ok_ice_supersat) THEN
+          IF (ok_bs) THEN
+             d_qx(i,k,ibs) = ( qbs_seri(i,k) - qx(i,k,ibs) ) / phys_tstep
+          ENDIF
+          IF (ok_ice_supersat) THEN
              d_qx(i,k,icf) = ( cf_seri(i,k) - qx(i,k,icf) ) / phys_tstep
              d_qx(i,k,iqvc) = ( qvc_seri(i,k) - qx(i,k,iqvc) ) / phys_tstep
-             IF (nqo.ge.6 .and. ok_plane_contrail) THEN
-               d_qx(i,k,icfa) = ( cfa_seri(i,k) - qx(i,k,icfa) ) / phys_tstep
-               d_qx(i,k,iqta) = ( qta_seri(i,k) - qx(i,k,iqta) ) / phys_tstep
-             ENDIF
           ENDIF
-
-           IF (nqo.ge.4 .and. ok_bs) THEN
-             d_qx(i,k,ibs) = ( qbs_seri(i,k) - qx(i,k,ibs) ) / phys_tstep
+          IF (ok_plane_contrail) THEN
+             d_qx(i,k,icfa) = ( cfa_seri(i,k) - qx(i,k,icfa) ) / phys_tstep
+             d_qx(i,k,ipcf) = ( pcf_seri(i,k) - qx(i,k,ipcf) ) / phys_tstep
+             d_qx(i,k,iqva) = ( qva_seri(i,k) - qx(i,k,iqva) ) / phys_tstep
+             d_qx(i,k,iqia) = ( qia_seri(i,k) - qx(i,k,iqia) ) / phys_tstep
           ENDIF
-
        ENDDO
     ENDDO
@@ -5754,5 +5768,7 @@
     qvc_ancien(:,:)= qvc_seri(:,:)
     cfa_ancien(:,:)= cfa_seri(:,:)
-    qta_ancien(:,:)= qta_seri(:,:)
+    pcf_ancien(:,:)= pcf_seri(:,:)
+    qva_ancien(:,:)= qva_seri(:,:)
+    qia_ancien(:,:)= qia_seri(:,:)
     CALL water_int(klon,klev,q_ancien,zmasse,prw_ancien)
     CALL water_int(klon,klev,ql_ancien,zmasse,prlw_ancien)
